package sk.upjs.finalTerm.quoridor2;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintWriter;

import javax.swing.JOptionPane;

import sk.upjs.jpaz2.ImageShape;
import sk.upjs.jpaz2.Turtle;
import sk.upjs.jpaz2.theater.Stage;

public class ClovekHrac extends HraciaDoska {

	public ClovekHrac(Stage quoridor) {
		super(quoridor);
	}

	public static final String NAME = "Player";

	public void bocnyPanelObrazky() {
		Turtle maliar = new Turtle();
		maliar.setPane(getSkoreCerveneLista());
		maliar.setShape(new ImageShape("images", "redPlayer.png"));
		maliar.setPosition(160, 50);
		maliar.stamp();
		maliar.setPane(getSkoreModreLista());
		maliar.setShape(new ImageShape("images", "bluePlayer.png"));
		maliar.setPosition(160, 50);
		maliar.stamp();
	}

	// obidvaja su "ludia"
	public void oblecKorytnacky() {
		add(getHrac1());
		add(getHrac2());
		getHrac1().setShape(new ImageShape("images", "bluePlayer.png"));
		getHrac2().setShape(new ImageShape("images", "redPlayer.png"));
		getHrac1().penUp();
		getHrac2().penUp();
		prekresliHracov();
	}

	public void ukonciTah() {

		setCervenyTah(!isCervenyTah());

		// ak hra bezi, a na tahu je cerveny, zastav stopky modremu a spusti stopky
		// cervenemu
		if (!isKoniecHry()) {
			if (isCervenyTah()) {
				getCasModry().stop();
				getCasCerveny().start();
				setSucetSkorecerv(Stopky.getTrvanie() + getSucetSkorecerv());
				getSkoreModreLista().vypis(Long.toString(getSucetSkorecerv()));
			}
			if (!isCervenyTah()) {
				getCasCerveny().stop();
				getCasModry().start();
				setSucetSkoremodr(Stopky.getTrvanie() + getSucetSkoremodr());
				getSkoreCerveneLista().vypis(Long.toString(getSucetSkoremodr()));
			}
		}

		// overi ci hra uz skoncila
		overVyhru();

		// ak skoncila vypni stopky
		if (isKoniecHry()) {
			getCasModry().stop();
			getCasCerveny().stop();
			Stopky.setTrvanie(0);
		}

		odstranStenuZoZasobnika();
		prekresliHracov();

		for (Turtle b : getMozneTahyKreslici()) {
			add(b);
			b.setPosition(-100, -100);
			b.setVisible(false);
		}

		if (!isKoniecHry()) {
			VypoctoveMetody.vypocitajMozneTahy();
			HraciaDoska.vykresliMozneTahy();
		}

		bocnyPanelObrazky();

		// zapise skore do suboru
		if (isKoniecHry()) {
			long vyhercoveSkore = 0;
			if ((getCervenyPozicia() > 72)) {
				vyhercoveSkore = getSucetSkoremodr();
			} else {
				vyhercoveSkore = getSucetSkorecerv();
			}

			String zadanaHodnota = JOptionPane.showInputDialog(null,
					(getCervenyPozicia() > 72) ? "Červený vyhral!" : "Modrý vyhral!" + "\r\n" + "Napíš meno");

			String zadHod2 = zadanaHodnota.replaceAll("\\s+", "_");

			String zadHod3 = "anonym";
			if (zadHod2.length() > 20) {
				zadHod3 = zadHod2;
				zadHod3 = zadHod2.substring(0, 19);
			}
			if (!(zadHod2.length() > 20)) {
				zadHod3 = zadHod2;
				
			}

			String zadHod4 = zadHod3 + (1000 + (int)(Math.random() * ((9999 - 1000) + 1)));
			JOptionPane.showMessageDialog(null, "Skóre bolo zapísané do štatistiky pod menom " + zadHod3);

			File file = new File("/data/tabulka.txt");
			file.getParentFile().mkdirs();
			try (PrintWriter pw = new PrintWriter(new FileOutputStream(file, true))) {
				pw.append(zadHod4 + " " + vyhercoveSkore + "\r\n");
			} catch (FileNotFoundException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
		}
	}
}
