package sk.upjs.finalTerm.quoridor2;

import sk.upjs.jpaz2.AudioClip;
import sk.upjs.jpaz2.ImageShape;
import sk.upjs.jpaz2.ImageTurtleShape;
import sk.upjs.jpaz2.Turtle;
import sk.upjs.jpaz2.theater.Scene;
import sk.upjs.jpaz2.theater.Stage;
import java.util.ArrayList;
import java.util.List;


import java.awt.event.MouseEvent;

public abstract class HraciaDoska extends Scene {

	// nazov sceny
	public static final String NAME = "Hra";

	// konstanta
	private static final int dlzkaStranyStvorca = 60;

	// vytvori korytnacky
	private static Turtle nacrtV = new Turtle();
	private static Turtle nacrtH = new Turtle();

	private static Turtle hrac1 = new Turtle();
	private static Turtle hrac2 = new Turtle();

	// pole moznych tahov (mozne tahy su cisla policok)
	private static List<Integer> mozneTahy = new ArrayList<>();
	// pole korytnaciek/kreslicov moznych tahov
	private static List<Turtle> mozneTahyKreslici = new ArrayList<Turtle>(5);

	// true => na tahu je cerveny; false => na tahu je modry
	private static boolean cervenyTah = false;
	// false => hra bezi
	private static boolean koniecHry = false;

	// policka su cislovane od 1-81, 1 = lavy horny roh, 9 = pravy horny roh, ...
	// startovacie pozicie su uz urcene
	private static int cervenyPozicia = 5;
	private static int modryPozicia = 77;

	// hraci zacinaju s 10 stenami (podla pravidiel)
	private static int cervenyStenyZostatok = 10;
	private static int modryStenyZostatok = 10;

	// premenne pouzite pri vykresleni stien
	private static int xSuradnicaSteny;
	private static int ySuradnicaSteny;
	private static int stenaPozicia;

	// premenne pouzite pri vykresleni hraca
	private static int xSuradnicaHraca;
	private static int ySuradnicaHraca;
	private static int hracPozicia = 5;

	// uklada kde je ulozena stena; false => nie je stena
	private static boolean[] vSteny = new boolean[100];
	private static boolean[] hSteny = new boolean[100];

	// vytvori tlacidlo navrat do menu
	private DomovTlacidlo spat = new DomovTlacidlo(getStage());

	// steny v zasobniku
	private static List<Turtle> steny = new ArrayList<>(20);

	private static Stav skoreModreLista = new Stav(200, 100);
	private static Stav skoreCerveneLista = new Stav(200, 100);
	private static Stav stavHryLista1 = new Stav(200, 25);
	private static Stav stavHryLista2 = new Stav(200, 25);

	private static Stopky casCerveny = new Stopky();
	private static Stopky casModry = new Stopky();
	private static HudbaOnOff musicOnOff;
	private static Turtle restart;

	private long sucetSkorecerv = 0;
	private long sucetSkoremodr = 0;

	private AudioClip eatingClip;

	// konstruktor
	public HraciaDoska(Stage quoridor) {
		super(quoridor);
		pripravPlochu();
	}

	// zneviditelni steny v zasobniku
	// myslienka: korytnacky sa menia na nevididelne
	public void odstranStenuZoZasobnika() {
		for (int i = 0; i < 10 - getCervenyStenyZostatok(); i++) {
			steny.get(i).setVisible(false);
		}

		for (int i = 0; i < 10 - getModryStenyZostatok(); i++) {
			steny.get(i + 10).setVisible(false);
		}
	}

	// prida stopky do plochy na spravne pozicie
	public void inicializujStopky() {
		skoreCerveneLista.add(casCerveny);
		casCerveny.setPosition(10, 30);
		skoreModreLista.add(casModry);
		casModry.setPosition(10, 30);
	}

	// postavi hraciu plochu
	public void pripravPlochu() {

		setBorderWidth(0);
		// load audio
		eatingClip = new AudioClip("audio", "move.wav", true);

		// nakresli pozadie
		nakresliPozadie();

		// nakresli steny v deku
		for (int i = 0; i < 10; i++) {
			steny.add(new Turtle());
			add(steny.get(i));
			steny.get(i).penUp();
			steny.get(i).setShape(new ImageTurtleShape("images", "wallV.png"));
			steny.get(i).setPosition(i * 60 + 60, 10);
		}
		for (int i = 10; i < 20; i++) {
			steny.add(new Turtle());
			add(steny.get(i));
			steny.get(i).penUp();
			steny.get(i).setShape(new ImageShape("images", "wallV.png"));
			steny.get(i).setPosition((i - 10) * 60 + 60, 650);
		}

		// prida tlacidlo restart
		ImageShape restartIkona = new ImageShape("images", "restart.png");
		restart = new Turtle();
		add(restart);
		restart.setPosition(700, 320);
		restart.setShape(restartIkona);

		// prida tlacidlo navrat domov
		add(spat);
		spat.setPosition(620, 300);

		// prida tlacidlo na ovladanie hudby
		if (musicOnOff == null) {
			musicOnOff = new HudbaOnOff(getStage());
		}
		musicOnOff.aktualizujIkonu();
		musicOnOff.setPosition(740, 298);
		add(musicOnOff);

		// prida korytnacky na kreslenie moznych tahov do pola
		for (int i = 0; i < 5; i++) {
			mozneTahyKreslici.add(new Turtle());
			mozneTahyKreslici.get(i).penUp();
			mozneTahyKreslici.get(i).setShape(new ImageShape("images", "greenDot.png"));
		}

		// prida do plochy hracov a "oblecie" ich
		oblecKorytnacky();

		// prida do plochy korytnacky, co su "oblecene ako steny"
		add(nacrtH);
		add(nacrtV);
		nacrtV.setPosition(-100, -100);
		nacrtH.setPosition(-100, -100);
		nacrtH.penUp();
		nacrtV.penUp();
		nacrtH.setShape(new ImageShape("images", "wallH.png"));
		nacrtV.setShape(new ImageShape("images", "wallV.png"));

		//
		

		// prida listy na vypisovanie
		skoreModreLista.setPosition(620, 440);
		add(skoreModreLista);
		skoreCerveneLista.setPosition(620, 110);
		add(skoreCerveneLista);
		this.add(stavHryLista1);
		this.add(stavHryLista2);
		stavHryLista1.setPosition(620, getSkoreCerveneLista().getY() + 80);
		stavHryLista2.setPosition(620, getSkoreModreLista().getY() +80);
		
		inicializujStopky();
	}

	public void restart() {
		// ukazovatele moznych poloh su pridane do plochy
		for (Turtle b : mozneTahyKreslici) {
			add(b);
			b.setVisible(true);
		}
		// hraci sa nastavia na zaciatocne pozicie
		cervenyPozicia = 5;
		modryPozicia = 77;

		// na tahu je modry; hra bezi
		cervenyTah = false;
		koniecHry = false;

		// hraci dostanu po 10 stien do zasobnika
		setCervenyStenyZostatok(10);
		setModryStenyZostatok(10);

		// steny, ktore boli v ploche sa odstrania, ale neprekreslia
		vSteny = new boolean[100];
		hSteny = new boolean[100];

		// steny v zasobnikoch sa zviditelnia
		for (int i = 0; i < 20; i++) {
			steny.get(i).setVisible(true);
		}

		// stopky sa vynuluju
		Stopky.setTrvanie(0);
		sucetSkorecerv = 0;
		sucetSkoremodr = 0;

		// vyprazdni listy
		skoreModreLista.vypis("");
		skoreCerveneLista.vypis("");

		// nakresli pozadie
		nakresliPozadie();
		ukonciTah();

	}

	// metoda, co kresli pozadie
	public void nakresliPozadie() {
		Turtle painter = new Turtle();
		painter.setShape(new ImageShape("images", "board.png"));
		add(painter);
		painter.center();
		painter.stamp();
		painter.setVisible(false);
		remove(painter);
	}

	// prezlecie korytnacky
	public abstract void oblecKorytnacky();

	// nakresli stvorce tam kde hrac moze ist
	public static void vykresliMozneTahy() {

		for (int i = 0; i < mozneTahy.size(); i++) {
			int reminder1 = mozneTahy.get(i) % 9;
			if (reminder1 == 0) {
				mozneTahyKreslici.get(i).setVisible(true);
				mozneTahyKreslici.get(i).moveTo((9 * dlzkaStranyStvorca) + dlzkaStranyStvorca / 2,
						((mozneTahy.get(i) / 9) * dlzkaStranyStvorca) + dlzkaStranyStvorca / 2);
			}
			if (reminder1 != 0) {
				mozneTahyKreslici.get(i).setVisible(true);
				mozneTahyKreslici.get(i).moveTo(((reminder1) * dlzkaStranyStvorca) + dlzkaStranyStvorca / 2,
						((mozneTahy.get(i) / 9) * dlzkaStranyStvorca) + dlzkaStranyStvorca + dlzkaStranyStvorca / 2);
			}
		}
	}

	// nakresli oboch hracov na spravnych poziciach
	public void prekresliHracov() {

		// modry hrac
		int reminder1 = modryPozicia % 9;
		if (reminder1 == 0) {
			hrac1.moveTo((9 * dlzkaStranyStvorca) + dlzkaStranyStvorca / 2,
					((modryPozicia / 9) * dlzkaStranyStvorca) + dlzkaStranyStvorca / 2);
		}
		if (reminder1 != 0) {
			hrac1.moveTo(((reminder1) * dlzkaStranyStvorca) + dlzkaStranyStvorca / 2,
					((modryPozicia / 9) * dlzkaStranyStvorca) + dlzkaStranyStvorca + dlzkaStranyStvorca / 2);
		}

		// cerveny hrac
		int reminder = cervenyPozicia % 9;
		if (reminder == 0) {
			hrac2.moveTo((9 * dlzkaStranyStvorca) + dlzkaStranyStvorca / 2,
					((cervenyPozicia / 9) * dlzkaStranyStvorca) + dlzkaStranyStvorca / 2);
		}
		if (reminder != 0) {
			hrac2.moveTo(((reminder) * dlzkaStranyStvorca) + dlzkaStranyStvorca / 2,
					((cervenyPozicia / 9) * dlzkaStranyStvorca) + dlzkaStranyStvorca + dlzkaStranyStvorca / 2);
		}
		if (musicOnOff.jeHudbaZapnuta())
			eatingClip.playAsActionSound();
	}

	// nacrtni (presun "oblecenu" korytnacku na poziciu, kde moze byt vertikalna
	// stena)
	public void nacrtniStenuVertikalnu(double x, double y) {
		nacrtV.setPosition(Math.round(x / 60) * 60, Math.ceil(y / 60) * 60);
	}

	// nacrtni (presun "oblecenu" korytnacku na poziciu, kde moze byt
	// horizontalna stena)
	public void nacrtniStenuHorizontalnu(double x, double y) {
		nacrtH.setPosition(Math.ceil(x / 60) * 60, Math.round(y / 60) * 60);
	}

	// nakresli vertikalnu stenu
	public void nakresliStenuVertikalnu() {
		Turtle maliar = new Turtle();
		add(maliar);
		for (int i = 0; i < 100; i++) {
			if (vSteny[i]) {
				maliar.setShape(new ImageShape("images", "wallV.png"));
				maliar.setPosition(dlzkaStranyStvorca * ((i - 1) % 9) + dlzkaStranyStvorca,
						dlzkaStranyStvorca * ((i - 1) / 9) + 2 * dlzkaStranyStvorca);
				maliar.stamp();
			}
		}
		remove(maliar);
	}

	// nakresli horizontalnu stenu
	public void nakresliStenuHorizontalnu() {
		Turtle maliar = new Turtle();
		add(maliar);
		for (int i = 0; i < 100; i++) {
			if (hSteny[i]) {
				maliar.setShape(new ImageShape("images", "wallH.png"));
				maliar.setPosition(dlzkaStranyStvorca * ((i) % 9) + dlzkaStranyStvorca,
						dlzkaStranyStvorca * ((i) / 9) + dlzkaStranyStvorca);
				maliar.stamp();
			}
		}
		remove(maliar);
	}
	
	// overi, ci hrac vyhral
	public void overVyhru() {
		if (getCervenyPozicia() > 72) {
			getStavHryLista1().vypis("Červený vyhral!");
			getStavHryLista2().vypis("Červený vyhral!");
			setKoniecHry(true);
		} else if (getModryPozicia() <= 9) {
			getStavHryLista1().vypis("Modrý vyhral!");
			getStavHryLista2().vypis("Modrý vyhral!");
			setKoniecHry(true);
		} else {
			if (isCervenyTah()) {
				getStavHryLista1().vypis("Červený choď");
				getStavHryLista2().vypis("");
			}
			if (!isCervenyTah()) {
				getStavHryLista1().vypis("");
				getStavHryLista2().vypis("Modrý choď");
			}
		}
	}
	

	// definicia tlacidla restart
	private boolean jeNadRestart(int x, int y) {
		return (restart.getX() - 20 <= x) && (x <= restart.getX() + 20) && (restart.getY() - 20 <= y)
				&& (y <= restart.getY() + 20);
	}

	protected void onMouseClicked(int x, int y, MouseEvent detail) {
		// simulacia tlacidla
		if (detail.getButton() == MouseEvent.BUTTON1) {
			if (jeNadRestart(x, y)) {
				this.restart();
			}
		}
	}

	@Override
	protected boolean onCanClick(int x, int y) {
		// zmeni kurzor
		return super.onCanClick(x, y) || jeNadRestart(x, y);
	}

	@Override
	protected void onMousePressed(int x, int y, MouseEvent detail) {

		if (detail.getButton() == MouseEvent.BUTTON1) {
			xSuradnicaSteny = (x + 5) / dlzkaStranyStvorca;
			ySuradnicaSteny = ((y + 5) / dlzkaStranyStvorca) - 1;
			setStenaPozicia(9 * ySuradnicaSteny + xSuradnicaSteny);
			xSuradnicaHraca = (x / dlzkaStranyStvorca);
			ySuradnicaHraca = (y / dlzkaStranyStvorca) - 1;
			hracPozicia = 9 * ySuradnicaHraca + xSuradnicaHraca;

			// Kliklo sa na hraciu plochu?
			if (x >= dlzkaStranyStvorca - 10 && x <= 10 * dlzkaStranyStvorca + 10 && y >= dlzkaStranyStvorca - 10
					&& y <= 10 * dlzkaStranyStvorca + 10 && !koniecHry) {
				// prida vertikalnu stenu a vykresli ju(kliklo sa blizko vertikalnej ciary)
				if ((x + 5) % dlzkaStranyStvorca <= 10 && (y + 5) % dlzkaStranyStvorca > 12) {
					// nesmu byt dve steny na tom istom mieste
					if (!vSteny[getStenaPozicia()] &&
					// steny musia byt v ploche
							getStenaPozicia() % 9 != 1 && getStenaPozicia() <= 72 &&
							// steny nesmu prechadzat cez seba
							!vSteny[Math.max(0, getStenaPozicia() - 9)] && !vSteny[getStenaPozicia() + 9]
							&& !hSteny[getStenaPozicia() + 8] &&
							// a hraci musia mat steny v zasobniku
							((cervenyTah && getCervenyStenyZostatok() > 0) || (!cervenyTah && getModryStenyZostatok() > 0))) {

						// az teraz pridaj vertikalnu stenu
						vSteny[getStenaPozicia()] = true;

						// over ci si nezablokoval hraca
						if (VypoctoveMetody.BreadthFirstSearch(cervenyPozicia, 82)
								&& VypoctoveMetody.BreadthFirstSearch(modryPozicia, 0)) {
							// ak je vsetko v poriadku odober stenu a ukonci tah
							if (cervenyTah)
								setCervenyStenyZostatok(getCervenyStenyZostatok() - 1);
							else
								setModryStenyZostatok(getModryStenyZostatok() - 1);
							ukonciTah();
							nakresliStenuVertikalnu();

						}
						// ak je nejaky hrac zablokovany, neuber stenu a neukonci tah
						else {
							vSteny[getStenaPozicia()] = false;
						}
					}
				}

				// prida horizontalnu stenu stenu a vykresli ju(kliklo sa blizko horizontalnej
				// ciary)
				else if ((y + 5) % dlzkaStranyStvorca <= 10 && (x + 5) % dlzkaStranyStvorca > 12) {
					// nemoze byt na tej istej pozicii
					if (!hSteny[getStenaPozicia()] &&
					// steny musia byt v ploche
							getStenaPozicia() % 9 > 0 && getStenaPozicia() > 9 && getStenaPozicia() < 82 &&
							// steny nesmu prechadzat cez seba
							!hSteny[Math.max(0, getStenaPozicia() - 1)] && !hSteny[getStenaPozicia() + 1]
							&& !vSteny[Math.max(0, getStenaPozicia() - 8)] &&
							// a hraci musia mat steny v zasobniku
							((cervenyTah && getCervenyStenyZostatok() > 0) || (!cervenyTah && getModryStenyZostatok() > 0))) {

						// az teraz pridaj horizontalnu stenu
						hSteny[getStenaPozicia()] = true;

						// over ci si nezablokoval hraca
						if (VypoctoveMetody.BreadthFirstSearch(cervenyPozicia, 82)
								&& VypoctoveMetody.BreadthFirstSearch(modryPozicia, 0)) {
							// ak je vsetko v poriadku odober stenu a ukonci tah
							if (cervenyTah)
								setCervenyStenyZostatok(getCervenyStenyZostatok() - 1);
							else
								setModryStenyZostatok(getModryStenyZostatok() - 1);

							ukonciTah();
							nakresliStenuHorizontalnu();
						}
						// ak je nejaky hrac zablokovany, neuber stenu a neukonci tah
						else {
							hSteny[getStenaPozicia()] = false;
						}
					}
				}

				// kliklo sa na policko ?
				else if (x % dlzkaStranyStvorca >= 10 && x % dlzkaStranyStvorca <= dlzkaStranyStvorca - 10
						&& y % dlzkaStranyStvorca >= 10 && y % dlzkaStranyStvorca <= dlzkaStranyStvorca - 10) {

					// ak je medzi moznymi tahmi chod na dane policko
					if (VypoctoveMetody.jeMozne(hracPozicia)) {
						pohniSpravnehoHraca();
					}
				}
			}
		}
	}

	// podobne ako onMousePressed, ale predkresli mozne polozenia stien a neukonci
	// tah
	@Override
	protected void onMouseMoved(int x, int y, MouseEvent detail) {
		xSuradnicaSteny = (x + 5) / dlzkaStranyStvorca;
		ySuradnicaSteny = ((y + 5) / dlzkaStranyStvorca) - 1;
		setStenaPozicia(9 * ySuradnicaSteny + xSuradnicaSteny);

		// vertikalna stena
		if (x >= dlzkaStranyStvorca && x <= 10 * dlzkaStranyStvorca && y >= dlzkaStranyStvorca
				&& y <= 10 * dlzkaStranyStvorca && !koniecHry) {
			if ((x + 5) % dlzkaStranyStvorca <= 10 && (y + 5) % dlzkaStranyStvorca > 12) {
				if (!vSteny[getStenaPozicia()] && getStenaPozicia() % 9 != 1 && getStenaPozicia() <= 72
						&& !vSteny[Math.max(0, getStenaPozicia() - 9)] && !vSteny[getStenaPozicia() + 9]
						&& !hSteny[getStenaPozicia() + 8]
						&& ((cervenyTah && getCervenyStenyZostatok() > 0) || (!cervenyTah && getModryStenyZostatok() > 0))) {

					// stena sa na chvilu polozi a overi sa ci tam moze byt...
					vSteny[getStenaPozicia()] = true;
					if (VypoctoveMetody.BreadthFirstSearch(cervenyPozicia, 82)
							&& VypoctoveMetody.BreadthFirstSearch(modryPozicia, 0)) {
						nacrtniStenuVertikalnu(x, y);
						nacrtH.moveTo(-100, -100);
						// ale po posunuti mysi prec sa hned odstrani
						vSteny[getStenaPozicia()] = false;
					} else {
						vSteny[getStenaPozicia()] = false;
					}
				} else {
					nacrtV.moveTo(-100, -100);
				}
			}

			// horizontalna stena
			else if ((y + 5) % dlzkaStranyStvorca <= 10 && (x + 5) % dlzkaStranyStvorca > 12) {
				if (!hSteny[getStenaPozicia()] && getStenaPozicia() % 9 > 0 && getStenaPozicia() > 9 && getStenaPozicia() < 82
						&& !hSteny[Math.max(0, getStenaPozicia() - 1)] && !hSteny[getStenaPozicia() + 1]
						&& !vSteny[Math.max(0, getStenaPozicia() - 8)]
						&& ((cervenyTah && getCervenyStenyZostatok() > 0) || (!cervenyTah && getModryStenyZostatok() > 0))) {
					hSteny[getStenaPozicia()] = true;
					if (VypoctoveMetody.BreadthFirstSearch(cervenyPozicia, 82)
							&& VypoctoveMetody.BreadthFirstSearch(modryPozicia, 0)) {
						nacrtniStenuHorizontalnu(x, y);
						nacrtV.moveTo(-100, -100);
						hSteny[getStenaPozicia()] = false;
					} else {
						hSteny[getStenaPozicia()] = false;
					}
				}

				// v ostatnych pripadoch posun korytnacku mimo plochu
			} else if (x % dlzkaStranyStvorca >= 10 && x % dlzkaStranyStvorca <= dlzkaStranyStvorca - 10
					&& y % dlzkaStranyStvorca >= 10 && y % dlzkaStranyStvorca <= dlzkaStranyStvorca - 10) {
				nacrtH.moveTo(-100, -100);
				nacrtV.moveTo(-100, -100);
			} else {
				nacrtH.moveTo(-100, -100);
			}
		}
	}

	// zabezpeci sa pohyb spravneho hraca
	public void pohniSpravnehoHraca() {
		if (cervenyTah)
			cervenyPozicia = hracPozicia;
		else {
			modryPozicia = hracPozicia;
		}
		ukonciTah();
	}

	// ina ked hra pocitac, ina ked hraci
	public abstract void ukonciTah();

	// pri kazdom prepnuti na hru sa hra nastavi na povodne nastavenia
	@Override
	public void start() {

		pripravPlochu();
		musicOnOff.aktualizujIkonu();
		restart();
	}

	@Override
	public void stop() {
		restart();
	}

	// setre a gettre
	public static boolean isKoniecHry() {
		return koniecHry;
	}

	public static void setKoniecHry(boolean koniecHry) {
		HraciaDoska.koniecHry = koniecHry;
	}

	public static int getCervenyPozicia() {
		return cervenyPozicia;
	}

	public static void setCervenyPozicia(int cervenyPozicia) {
		HraciaDoska.cervenyPozicia = cervenyPozicia;
	}

	public static int getModryPozicia() {
		return modryPozicia;
	}

	public static void setModryPozicia(int modryPozicia) {
		HraciaDoska.modryPozicia = modryPozicia;
	}

	public static List<Integer> getMozneTahy() {
		return mozneTahy;
	}

	public static void setMozneTahy(List<Integer> mozneTahy) {
		HraciaDoska.mozneTahy = mozneTahy;
	}

	public static List<Turtle> getMozneTahyKreslici() {
		return mozneTahyKreslici;
	}

	public static void setMozneTahyKreslici(List<Turtle> mozneTahyKreslici) {
		HraciaDoska.mozneTahyKreslici = mozneTahyKreslici;
	}

	public static boolean[] getvSteny() {
		return vSteny;
	}

	public static void setvSteny(boolean[] vSteny) {
		HraciaDoska.vSteny = vSteny;
	}

	public static boolean[] gethSteny() {
		return hSteny;
	}

	public static void sethSteny(boolean[] hSteny) {
		HraciaDoska.hSteny = hSteny;
	}

	public static boolean isCervenyTah() {
		return cervenyTah;
	}

	public static void setCervenyTah(boolean redTurn) {
		HraciaDoska.cervenyTah = redTurn;
	}

	public static Turtle getNacrtV() {
		return nacrtV;
	}

	public static void setNacrtV(Turtle nacrtV) {
		HraciaDoska.nacrtV = nacrtV;
	}

	public static Turtle getNacrtH() {
		return nacrtH;
	}

	public static void setNacrtH(Turtle nacrtH) {
		HraciaDoska.nacrtH = nacrtH;
	}

	public static Turtle getHrac1() {
		return hrac1;
	}

	public static void setHrac1(Turtle hrac1) {
		HraciaDoska.hrac1 = hrac1;
	}

	public static Turtle getHrac2() {
		return hrac2;
	}

	public static void setHrac2(Turtle hrac2) {
		HraciaDoska.hrac2 = hrac2;
	}

	public static Stav getSkoreModreLista() {
		return skoreModreLista;
	}

	public static void setSkoreModreLista(Stav skoreModreLista) {
		HraciaDoska.skoreModreLista = skoreModreLista;
	}

	public static Stav getSkoreCerveneLista() {
		return skoreCerveneLista;
	}

	public static void setSkoreCerveneLista(Stav skoreCerveneLista) {
		HraciaDoska.skoreCerveneLista = skoreCerveneLista;
	}

	public static Stav getStavHryLista1() {
		return stavHryLista1;
	}

	public static void setStavHryLista1(Stav stavHryLista) {
		HraciaDoska.stavHryLista1 = stavHryLista;
	}
	public static Stav getStavHryLista2() {
		return stavHryLista2;
	}

	public static void setStavHryLista2(Stav stavHryLista) {
		HraciaDoska.stavHryLista2 = stavHryLista;
	}

	public static Stopky getCasModry() {
		return casModry;
	}

	public static void setCasModry(Stopky casModry) {
		HraciaDoska.casModry = casModry;
	}

	public static Stopky getCasCerveny() {
		return casCerveny;
	}

	public static void setCasCerveny(Stopky casCerveny) {
		HraciaDoska.casCerveny = casCerveny;
	}

	public long getSucetSkorecerv() {
		return sucetSkorecerv;
	}

	public void setSucetSkorecerv(long sucetSkorecerv) {
		this.sucetSkorecerv = sucetSkorecerv;
	}

	public long getSucetSkoremodr() {
		return sucetSkoremodr;
	}

	public void setSucetSkoremodr(long sucetSkoremodr) {
		this.sucetSkoremodr = sucetSkoremodr;
	}

	public static int getStenaPozicia() {
		return stenaPozicia;
	}

	public static void setStenaPozicia(int stenaPozicia) {
		HraciaDoska.stenaPozicia = stenaPozicia;
	}

	public static int getCervenyStenyZostatok() {
		return cervenyStenyZostatok;
	}

	public static void setCervenyStenyZostatok(int cervenyStenyZostatok) {
		HraciaDoska.cervenyStenyZostatok = cervenyStenyZostatok;
	}

	public static int getModryStenyZostatok() {
		return modryStenyZostatok;
	}

	public static void setModryStenyZostatok(int modryStenyZostatok) {
		HraciaDoska.modryStenyZostatok = modryStenyZostatok;
	}

}
