package sk.upjs.finalTerm.quoridor2;

import java.awt.event.MouseEvent;

import sk.upjs.jpaz2.*;
import sk.upjs.jpaz2.theater.*;

// tlacidlo na hudbu zapnuta/vypnuta
public class HudbaOnOff extends Pane {

	private Turtle ikona;
	
	//kontrolovany "stage"  
	private Stage stage;

	// konstruktor, vytvori tlacidlo
	public HudbaOnOff(Stage stage) {
		this.stage = stage;
		setBorderWidth(0);
		setTransparentBackground(true);

		// rozdelim obrazok na dva(vypnuty/zapnuty zvuk)
		ImageShape.Builder imageBuilder = new ImageShape.Builder("images", "soundicon.png");
		imageBuilder.setViewCount(2);
		// vytvor obrazok podla aktualnych nastaveni "imageBuilder"-a
		ImageShape ikonaTvar = imageBuilder.createShape();
		// nastav velkost "plochy(pane)" podla velkosti ikony
		resize(ikonaTvar.getWidth(), ikonaTvar.getHeight());

		// vytvor korytnacku, ktora ma tvar ikony
		ikona = new Turtle();
		ikona.setShape(ikonaTvar);
		add(ikona);
		ikona.center();
	}

	// zmeni ikonu podla toho, ci je zvuk zapnuty/vypnuty
	public void aktualizujIkonu() {
		if (jeHudbaZapnuta()) {
			ikona.setViewIndex(0);
		} else {
			ikona.setViewIndex(1);
		}
	}

	// vrati true ak hudba je zapnuta
	public boolean jeHudbaZapnuta() {
		return stage.getBackgroundMusic().isPlaying();
	}

	// vypne/zapne hudbu
	public void setMusicOn(boolean hudbaZapnuta) {
		stage.setMutedMusic(!hudbaZapnuta);
		aktualizujIkonu();
	}

	@Override
	protected void onMouseReleased(int x, int y, MouseEvent detail) {
		// pri pusteni tlacidla vypni/zapni hudbu
		if (detail.getButton() == MouseEvent.BUTTON1) {
			setMusicOn(!jeHudbaZapnuta());
		}
	}

	@Override
	protected boolean onCanClick(int x, int y) {
		// zmeni kurzor nad ikonou(nie paneom)
		return ikona.containsInShape(x, y);
	}
}