package sk.upjs.finalTerm.quoridor2;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.List;
import javax.swing.JOptionPane;
import sk.upjs.jpaz2.ImageShape;
import sk.upjs.jpaz2.Turtle;
import sk.upjs.jpaz2.theater.Stage;

public class PocitacHrac extends HraciaDoska {

	public static final String NAME = "Umela inteligencia";

	public PocitacHrac(Stage quoridor) {
		super(quoridor);
	}

	// nakresli po kazdom kole pri skore aj cerveneho a modreho hraca
	public void bocnyPanelObrazky() {
		Turtle maliar = new Turtle();
		maliar.setPane(getSkoreCerveneLista());
		maliar.setShape(new ImageShape("images", "redPlayer.png"));
		maliar.setPosition(160, 50);
		maliar.stamp();
		maliar.setPane(getSkoreModreLista());
		maliar.setShape(new ImageShape("images", "computerBlue.png"));
		maliar.setPosition(160, 50);
		maliar.stamp();
		remove(maliar);
	}

	// "oblec" modreho ako pocitac, cerveneho ako hraca
	public void oblecKorytnacky() {
		add(getHrac1());
		add(getHrac2());
		getHrac1().setShape(new ImageShape("images", "computerBlue.png"));
		getHrac2().setShape(new ImageShape("images", "redPlayer.png"));
		getHrac1().penUp();
		getHrac2().penUp();
		prekresliHracov();
	}

	// pouzije sa na pohnutie pocitaca na najvyhodnejsie policko
	public void chod(List<Vertex> path) {
		if (VypoctoveMetody.jeMozne(Integer.parseInt(path.get(1).toString()) + 1)) {
			setModryPozicia(Integer.parseInt(path.get(1).toString()) + 1);
		}
		if (path.size() > 2) {
			if (!VypoctoveMetody.jeMozne(Integer.parseInt(path.get(1).toString()) + 1)
					&& VypoctoveMetody.jeMozne(Integer.parseInt(path.get(2).toString()) + 1)) {
				setModryPozicia(Integer.parseInt(path.get(2).toString()) + 1);
			}
			if (!VypoctoveMetody.jeMozne(Integer.parseInt(path.get(1).toString()) + 1)
					&& !VypoctoveMetody.jeMozne(Integer.parseInt(path.get(2).toString()) + 1)) {
				setModryPozicia(getMozneTahy().get(0));
			}
		}

		else {
			setModryPozicia(getMozneTahy().get(0));
		}
	}

	public void ukonciTah() {
		// pouzije sa na najdenie najkratsej cesty pocitaca(cisla policok po ktorych
		// musi ist aby dosiel co najrychlejsie do ciela)
		List<Vertex> path = null;

		// premenne pouzite pri hladani najvhodnejsieho polozenia horizontalnej steny
		int posledneminimum = 500;
		int min = 500;
		int poslednemaximum = -5;
		int min2 = 500;
		int index = -9;
		int indexMin2 = 0;
		int indexMin = 0;

		// premenne pouzite pri hladani najvhodnejsieho polozenia vertikalnej steny
		int posledneminimumVer = 500;
		int minVer = 500;
		int poslednemaximumVer = -5;
		int min2Ver = 500;
		int indexVer = -9;
		int indexMin2Ver = 0;
		int indexMinVer = 0;

		// ====zaciatok======hladanie najvyhodnejsej horizontalnej/vertikalnej steny
		// vertikalne steny hladanie najlepsej
		for (int k = 0; k < 72; k++) {
			// ak na danej polohe este nie je stena, tak ju tam daj
			if (getvSteny()[k + 2] == false) {
				setStenaPozicia(k + 2);
				if (!getvSteny()[getStenaPozicia()] &&
				// steny musia byt v ploche
						getStenaPozicia() % 9 != 1 && getStenaPozicia() <= 72 &&
						// steny nesmu prechadzat cez seba
						!getvSteny()[Math.max(0, getStenaPozicia() - 9)] && !getvSteny()[getStenaPozicia() + 9]
						&& !gethSteny()[getStenaPozicia() + 8] &&
						// a hraci musia mat steny v zasobniku
						((isCervenyTah() && getCervenyStenyZostatok() > 0)
								|| (!isCervenyTah() && getModryStenyZostatok() > 0))) {
					// az teraz pridaj vertikalnu stenu
					getvSteny()[getStenaPozicia()] = true;
					// over ci si nezablokoval hraca
					if (VypoctoveMetody.BreadthFirstSearch(getCervenyPozicia(), 82)
							&& VypoctoveMetody.BreadthFirstSearch(getModryPozicia(), 0)) {
						// ak je vsetko v poriadku odober stenu a ukonci tah
					}
					// ak je nejaky hrac zablokovany, neuber stenu a neukonci tah
					else {
						getvSteny()[getStenaPozicia()] = false;
					}
				}

				// Vytvorim graf s 81 bodmi(tu su cislovane 0-80)(moje policka/vertex) a
				// cestami(edges)
				Edge[] edges = null;
				Graph graph = new Graph();
				Vertex[] vertices = new Vertex[81];
				for (int i = 0; i < vertices.length; i++) {
					vertices[i] = new Vertex(i + "");
					graph.addVertex(vertices[i], true);
				}
				// stacilo by 144, ale este 5 bude treba (mozne tahy modreho)
				edges = new Edge[150];
				for (int i = 0; i < 72; i++) {
					if (VypoctoveMetody.doleOk(i + 1)) {
						edges[i] = new Edge(vertices[i], vertices[i + 9], 1);
					}
				}
				int j = 72;
				for (int i = 0; i < 80; i++) {
					if (i % 9 != 8 && VypoctoveMetody.spravaOk(i + 1)) {
						edges[j] = new Edge(vertices[i], vertices[i + 1], 1);
						j++;
					}
				}
				// prida modremu pocitacu dalsie cesty
				if (isCervenyTah() == true) {
					setCervenyTah(!isCervenyTah());
					VypoctoveMetody.vypocitajMozneTahy();
					setCervenyTah(!isCervenyTah());
					for (int i = 145; i < getMozneTahy().size() + 145; i++) {
						edges[i] = new Edge(vertices[getModryPozicia() - 1], vertices[getMozneTahy().get(i - 145) - 1],
								1);
					}
				}

				// vytvori graf (vsetky cesty medzi polickami)
				for (Edge e : edges) {
					if (e != null) {
						graph.addEdge(e.getOne(), e.getTwo(), e.getWeight());
					}

				}

				// hladanie najkratsej cesty modry
				Dijkstra dijkstra = new Dijkstra(graph, vertices[getModryPozicia() - 1].getLabel());
				int[] vzdialenostiVer = new int[9];
				for (int i = 0; i < 9; i++) {
					if (VypoctoveMetody.BreadthFirstSearch(getModryPozicia(), 0)) {
						int vzd = dijkstra.getDistanceTo(Integer.toString(i));
						vzdialenostiVer[i] = vzd;
					} else {
						vzdialenostiVer[i] = 0;
					}
				}
				indexMinVer = 0;
				minVer = 500;
				for (int i = 0; i < vzdialenostiVer.length; i++) {
					if (minVer > vzdialenostiVer[i] && minVer != 0) {
						minVer = vzdialenostiVer[i];
						indexMinVer = i;
					}
				}
				// ====================================== hladanie min koniec

				// hladanie najkratsej cesty cerveny
				Dijkstra dijkstra2 = new Dijkstra(graph, vertices[getCervenyPozicia() - 1].getLabel());

				// cielovych policok je 9(teda cely rad), ja hladam iba to policko ku ktoremu je
				// najkratsia cesta
				int[] vzdialenosti2Ver = new int[9];
				// naplni pole vzdialenosti2Ver vzdialenostami k jednotlivym polickam cieloveho
				// radu
				for (int i = 0; i < 9; i++) {
					if (VypoctoveMetody.BreadthFirstSearch(getCervenyPozicia(), 82)) {
						int vzd2Ver = dijkstra2.getDistanceTo(Integer.toString(i + 72));
						vzdialenosti2Ver[i] = vzd2Ver;
					} else {
						vzdialenosti2Ver[i] = 0;
					}
				}

				// najde to policko, ktore je nablizsie
				// min2Ver je dlzka najkratsej cesty
				// indexMin2Ver je index na ktorom sa nachadza najkratsia cesta
				indexMin2Ver = 0;
				min2Ver = 500;
				for (int i = 0; i < vzdialenosti2Ver.length; i++) {
					if (min2Ver > vzdialenosti2Ver[i] && min2Ver != 0) {
						min2Ver = vzdialenosti2Ver[i];
						indexMin2Ver = i;
					}
				}

				// hlada sucasnu vertikalnu stenu pri stene na ?
				if (minVer < posledneminimumVer) {
					posledneminimumVer = minVer;
				}

				// zisti pri akej pozicii vertikalnej steny, bude najkratsia mozna cesta
				// cerveneho najdlhsia
				if (min2Ver > poslednemaximumVer) {
					poslednemaximumVer = min2Ver;
					indexVer = k + 2;
				}
				// stenu ktoru na zaciatku testovania polozilo opat odstrani
				getvSteny()[getStenaPozicia()] = false;
			}
		}

		///////////////////////////////////////////////

		// hladanie najlepsej horizontalnej steny (analogicky, podobne ako vertikalna
		// stena)
		for (int k = 0; k < 72; k++) {
			if (gethSteny()[k + 9] == false) {
				setStenaPozicia(k + 9);

				if (!gethSteny()[getStenaPozicia()] &&
				// steny musia byt v ploche
						getStenaPozicia() % 9 > 0 && getStenaPozicia() > 9 && getStenaPozicia() < 82 &&
						// steny nesmu prechadzat cez seba
						!gethSteny()[Math.max(0, getStenaPozicia() - 1)] && !gethSteny()[getStenaPozicia() + 1]
						&& !getvSteny()[Math.max(0, getStenaPozicia() - 8)] &&
						// a hraci musia mat steny v zasobniku
						((isCervenyTah() && getCervenyStenyZostatok() > 0)
								|| (!isCervenyTah() && getModryStenyZostatok() > 0))) {

					// az teraz pridaj horizontalnu stenu
					gethSteny()[getStenaPozicia()] = true;

					// over ci si nezablokoval hraca
					if (VypoctoveMetody.BreadthFirstSearch(getCervenyPozicia(), 82)
							&& VypoctoveMetody.BreadthFirstSearch(getModryPozicia(), 0)) {
					}
					// ak je nejaky hrac zablokovany, neuber stenu a neukonci tah
					else {
						gethSteny()[getStenaPozicia()] = false;
					}
				}

				Edge[] edges = null;
				Graph graph = new Graph();
				// v mojom pripade policka
				Vertex[] vertices = new Vertex[81];
				for (int i = 0; i < vertices.length; i++) {
					vertices[i] = new Vertex(i + "");
					graph.addVertex(vertices[i], true);
				}
				// stacilo by 144, ale este 5 bude treba
				edges = new Edge[150];
				for (int i = 0; i < 72; i++) {
					if (VypoctoveMetody.doleOk(i + 1)) {
						edges[i] = new Edge(vertices[i], vertices[i + 9], 1);
					}
				}
				int j = 72;
				for (int i = 0; i < 80; i++) {
					if (i % 9 != 8 && VypoctoveMetody.spravaOk(i + 1)) {
						edges[j] = new Edge(vertices[i], vertices[i + 1], 1);
						j++;
					}
				}
				// prida modremu pocitacu dalsie cesty
				if (isCervenyTah() == true) {
					setCervenyTah(!isCervenyTah());
					VypoctoveMetody.vypocitajMozneTahy();
					setCervenyTah(!isCervenyTah());

					for (int i = 145; i < getMozneTahy().size() + 145; i++) {
						edges[i] = new Edge(vertices[getModryPozicia() - 1], vertices[getMozneTahy().get(i - 145) - 1],
								1);
					}
				}
				// vytvori graf (vsetky cesty medzi polickami)
				for (Edge e : edges) {
					if (e != null) {
						graph.addEdge(e.getOne(), e.getTwo(), e.getWeight());
					}

				}

				// hladanie najkratsej cesty modry
				Dijkstra dijkstra = new Dijkstra(graph, vertices[getModryPozicia() - 1].getLabel());
				int[] vzdialenosti = new int[9];
				for (int i = 0; i < 9; i++) {
					if (VypoctoveMetody.BreadthFirstSearch(getModryPozicia(), 0)) {
						int vzd = dijkstra.getDistanceTo(Integer.toString(i));
						vzdialenosti[i] = vzd;
					} else {
						vzdialenosti[i] = 0;
					}
				}
				indexMin = 0;
				min = 500;
				for (int i = 0; i < vzdialenosti.length; i++) {
					if (min > vzdialenosti[i] && min != 0) {
						min = vzdialenosti[i];
						indexMin = i;
					}
				}

				// hladanie najkratsej cesty cerveny
				Dijkstra dijkstra2 = new Dijkstra(graph, vertices[getCervenyPozicia() - 1].getLabel());
				int[] vzdialenosti2 = new int[9];
				for (int i = 0; i < 9; i++) {
					if (VypoctoveMetody.BreadthFirstSearch(getCervenyPozicia(), 82)) {
						int vzd2 = dijkstra2.getDistanceTo(Integer.toString(i + 72));
						vzdialenosti2[i] = vzd2;
					} else {
						vzdialenosti2[i] = 0;
					}
				}
				indexMin2 = 0;
				min2 = 500;
				for (int i = 0; i < vzdialenosti2.length; i++) {
					if (min2 > vzdialenosti2[i] && min2 != 0) {
						min2 = vzdialenosti2[i];
						indexMin2 = i;
					}
				}

				// cisla policok po ktorych modry pojde
				path = dijkstra.getPathTo(Integer.toString(indexMin));

				//
				if (min < posledneminimum) {
					posledneminimum = min;
				}

				// sucasne minimum cerveneho pri stene na index
				if (min2 > poslednemaximum) {
					poslednemaximum = min2;
					index = k + 9;
				}

				// horizontalnu stenu ktoru tesoval nastavi na false
				gethSteny()[getStenaPozicia()] = false;
			}
		}

		// ====koniec======hladanie najvyhodnejsej horizontalnej/vertikalnej steny

		setCervenyTah(!isCervenyTah());

		// over ci je koniec
		overVyhru();

		// ==============================
		if (min % 2 == 1 && !isKoniecHry()) {
			// ak polozenim horizontalnej steny ziskam dlhsiu alebo rovnu trasu ako pri
			// polozeni vertikalnej poloz horizontalnu
			if (poslednemaximum >= poslednemaximumVer) {
				setStenaPozicia(index);
				if (!gethSteny()[getStenaPozicia()] &&
				// steny musia byt v ploche
						getStenaPozicia() % 9 > 0 && getStenaPozicia() > 9 && getStenaPozicia() < 82 &&
						// steny nesmu prechadzat cez seba
						!gethSteny()[Math.max(0, getStenaPozicia() - 1)] && !gethSteny()[getStenaPozicia() + 1]
						&& !getvSteny()[Math.max(0, getStenaPozicia() - 8)] &&
						// a hraci musia mat steny v zasobniku
						((isCervenyTah() && getCervenyStenyZostatok() > 0)
								|| (!isCervenyTah() && getModryStenyZostatok() > 0))) {
					// az teraz pridaj horizontalnu stenu
					gethSteny()[getStenaPozicia()] = true;

					// over ci si nezablokoval hraca
					if (VypoctoveMetody.BreadthFirstSearch(getCervenyPozicia(), 82)
							&& VypoctoveMetody.BreadthFirstSearch(getModryPozicia(), 0)) {
						// ak je vsetko v poriadku odober stenu a ukonci tah
						if (isCervenyTah())
							setCervenyStenyZostatok(getCervenyStenyZostatok() - 1);
						else
							setModryStenyZostatok(getModryStenyZostatok() - 1);
					}
					// ak je nejaky hrac zablokovany, neuber stenu a neukonci tah
					else {
						gethSteny()[getStenaPozicia()] = false;
					}
				}
				nakresliStenuHorizontalnu();

				// ak si nemohol polozit stenu urob tah
				if (gethSteny()[getStenaPozicia()] == false) {
					VypoctoveMetody.vypocitajMozneTahy();
					chod(path);

					prekresliHracov();
					setCervenyTah(!isCervenyTah());
				}
				// zmeni tah na cerveneho(cloveka)
				if (gethSteny()[getStenaPozicia()] == true) {
					setCervenyTah(!isCervenyTah());
				}
			}

			// ak polozenim vertikalnej steny ziskam dlhsiu trasu ako pri
			// polozeni horizontalnej poloz vertikalnu
			if (poslednemaximum < poslednemaximumVer) {
				setStenaPozicia(indexVer);
				if (!getvSteny()[getStenaPozicia()] &&
				// steny musia byt v ploche
						getStenaPozicia() % 9 != 1 && getStenaPozicia() <= 72 &&
						// steny nesmu prechadzat cez seba
						!getvSteny()[Math.max(0, getStenaPozicia() - 9)] && !getvSteny()[getStenaPozicia() + 9]
						&& !gethSteny()[getStenaPozicia() + 8] &&
						// a hraci musia mat steny v zasobniku
						((isCervenyTah() && getCervenyStenyZostatok() > 0)
								|| (!isCervenyTah() && getModryStenyZostatok() > 0))) {
					// az teraz pridaj vertikalnu stenu
					getvSteny()[getStenaPozicia()] = true;
					// over ci si nezablokoval hraca
					if (VypoctoveMetody.BreadthFirstSearch(getCervenyPozicia(), 82)
							&& VypoctoveMetody.BreadthFirstSearch(getModryPozicia(), 0)) {
						// ak je vsetko v poriadku odober stenu a ukonci tah
						if (isCervenyTah())
							setCervenyStenyZostatok(getCervenyStenyZostatok() - 1);
						else
							setModryStenyZostatok(getModryStenyZostatok() - 1);
						nakresliStenuVertikalnu();
					}
					// ak je nejaky hrac zablokovany, neuber stenu a neukonci tah
					else {
						getvSteny()[getStenaPozicia()] = false;
					}
				}
				nakresliStenuVertikalnu();

				// ak si nemohol polozit stenu urob tah
				if (getvSteny()[getStenaPozicia()] == false) {
					VypoctoveMetody.vypocitajMozneTahy();
					chod(path);
					prekresliHracov();
					setCervenyTah(!isCervenyTah());
				}
				if (getvSteny()[getStenaPozicia()] == true) {
					setCervenyTah(!isCervenyTah());
				}
			}
		}

		// v ostatnych pripadoch iba urob tah
		else {
			if (!isCervenyTah() && !isKoniecHry()) {
				VypoctoveMetody.vypocitajMozneTahy();
				chod(path);
				prekresliHracov();
				setCervenyTah(!isCervenyTah());
			}
		}

		// =======================================================================

		// over ci hra skoncila (potom co modry spravil tah)
		overVyhru();

		// ak skoncila vypni stopky
		if (isKoniecHry()) {
			getCasModry().stop();
			getCasCerveny().stop();
			Stopky.setTrvanie(0);
		}

		odstranStenuZoZasobnika();
		prekresliHracov();

		for (Turtle b : getMozneTahyKreslici()) {
			add(b);
			b.setPosition(-100, -100);
			b.setVisible(false);
		}

		if (!isKoniecHry()) {
			VypoctoveMetody.vypocitajMozneTahy();
			HraciaDoska.vykresliMozneTahy();
		}

		// stopky on/off
		if (!isKoniecHry()) {
			if (isCervenyTah()) {
				getCasModry().stop();
				getCasCerveny().start();
				setSucetSkorecerv(Stopky.getTrvanie() + getSucetSkorecerv());
				getSkoreCerveneLista().vypis(Long.toString(getSucetSkorecerv()));
			}
			if (!isCervenyTah()) {
				getCasCerveny().stop();
				getCasModry().start();
				setSucetSkoremodr(Stopky.getTrvanie() + getSucetSkoremodr());
				getSkoreCerveneLista().vypis(Long.toString(getSucetSkoremodr()));
			}
		}

		// prekresli
		bocnyPanelObrazky();

		// na zapisanie skore pri vyhre pocitaca nezapisuj nic, iba ak vyhra hrac
		if (isKoniecHry() && getCervenyPozicia() > 72) {
			long vyhercoveSkore = 0;
			vyhercoveSkore = getSucetSkorecerv();
			String zadanaHodnota = JOptionPane.showInputDialog(null, "Červený vyhral!"+"\r\n"+ "Napíš svoje meno");
			String zadHod2 = zadanaHodnota.replaceAll("\\s+", "_");

			String zadHod3 = "anonym";
			if (zadHod2.length() > 20) {
				zadHod3 = zadHod2;
				zadHod3 = zadHod2.substring(0, 19);
			}
			if (!(zadHod2.length() > 20)) {
				zadHod3 = zadHod2;
			}

			String zadHod4 = zadHod3 + (1000 + (int)(Math.random() * ((9999 - 1000) + 1)));
			JOptionPane.showMessageDialog(null, "Skóre bolo zapísané do štatistiky pod menom " + zadHod3);
			
			PrintWriter pw = null;
			try {
				File file = new File("/data/tabulka.txt");
				file.getParentFile().mkdirs();
				pw = new PrintWriter(new FileOutputStream(file, true));
				pw.append(zadHod4 + " " + vyhercoveSkore + "\r\n");

			} catch (FileNotFoundException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			} finally {	
				if (pw != null) {
					pw.close();
				}
			}
		}
	}
}
