
package sk.upjs.finalTerm.quoridor2;

import java.awt.Font;
import java.awt.geom.Point2D;
import java.io.File;
import java.io.FileNotFoundException;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;
import sk.upjs.jpaz2.ImageShape;
import sk.upjs.jpaz2.Turtle;
import sk.upjs.jpaz2.theater.Scene;
import sk.upjs.jpaz2.theater.Stage;

public class Statistika extends Scene {

	private static Turtle pisar;
	private static Turtle animacia;

	public static final String NAME = "Statistika";

	private DomovTlacidlo spat = new DomovTlacidlo(getStage());
	private HudbaOnOff hudba;

	// konstruktor
	public Statistika(Stage stage) {
		super(stage);
		pripravPlochu();
		skoreTopDesiati(new File("/data/tabulka.txt"));

	}

	// pripravi plochu
	private void pripravPlochu() {
		setBorderWidth(0);

		pisar = new Turtle();
		add(pisar);
		pisar.setDirection(90);

		// animacia
		animacia = new Turtle();
		add(animacia);
		animacia.setPosition(680, 530);
		animacia.setScale(0.5);
		animacia.setShape(new ImageShape("images", "cena.gif"));
		animacia.setShapeAnimation(false);
		// nakresli pravidla ako obrazok
		nakresliPozadie();

		// prida tlacidlo domov
		add(spat);
		spat.setPosition(5, 5);

		// prida tlacidlo hudba
		hudba = new HudbaOnOff(getStage());
		hudba.setPosition(50, 5);
		add(hudba);
	}

	// najde hracov s najlepsim skore (najlepsie skore je to najnizsie, lebo je to
	// cas v milisekundach)(teda cas ktory potreboval hrac na vyhratie)

	public static void skoreTopDesiati(File stream) {
		Map<String, Long> menovky = new HashMap<>();

		try (Scanner sc = new Scanner(stream)) {
			while (sc.hasNext()) {
				String meno = sc.next();
				if (sc.hasNextLong()) {
					menovky.put(meno, sc.nextLong());
				}
			}

		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		pisar.setPosition(50, 150);
		pisar.penUp();
		pisar.setVisible(false);
		for (int i = 0; i < 10; i++) {
			if (menovky.size() == 0) {
				break;
			}

			String najHrac = "0";
			Long najPocet = Long.MAX_VALUE;
			Set<String> mnozinaMena = menovky.keySet();
			for (String meno : mnozinaMena) {
				if (menovky.get(meno) < najPocet) {
					najHrac = meno;
					najPocet = menovky.get(meno);
				}
			}
			Point2D zaciatok = pisar.getPosition();

			
			String najHrac2= najHrac.substring(0, najHrac.length()-4);
			
			pisar.setFont(new Font("Trebuchet MS", 1, 25));
			pisar.print(i + 1 + ". " + najHrac2);
			pisar.moveTo(zaciatok);
			pisar.step(350);
			pisar.print(najPocet + "");
			pisar.moveTo(zaciatok);
			pisar.moveTo(pisar.getX(), pisar.getY() + 40);
			menovky.remove(najHrac);
		}

	}

	private void nakresliPozadie() {
		Turtle maliar = new Turtle();
		maliar.setFont(new Font("SansSerif", 1, 40));
		maliar.setShape(new ImageShape("images", "statistika.png"));
		add(maliar);
		maliar.center();
		maliar.stamp();
		maliar.setPosition((getWidth() / 2), 50);
		maliar.setDirection(90);
		maliar.printCenter("Štatistika");
		remove(maliar);

	}

	@Override
	public void start() {
		nakresliPozadie();
		hudba.aktualizujIkonu();
		skoreTopDesiati(new File("/data/tabulka.txt"));
		animacia.setShapeAnimation(true);
	}

	@Override
	public void stop() {
		animacia.setShapeAnimation(false);

	}
}
