package sk.upjs.finalTerm.quoridor2;

import java.awt.Font;

import sk.upjs.jpaz2.ImageTurtleShape;
import sk.upjs.jpaz2.Pane;
import sk.upjs.jpaz2.Turtle;

public class Stopky extends Pane {

	private static long zaciatocnyCas;
	private static long trvanie = 0;

	private Turtle pisar;
	private Turtle maliarPozadia;

	// konstruktor
	public Stopky() {
		resize(100, 40);
		setTransparentBackground(true);
		setBorderWidth(0);

		pisar = new Turtle();
		add(this.pisar);
		pisar.setFont(new Font("Serif", 1, 15));
		pisar.setPosition(40.0, 23.0);
		pisar.setDirection(90.0);
		pisar.setVisible(false);

		maliarPozadia = new Turtle();
		add(maliarPozadia);
		maliarPozadia.center();
		maliarPozadia.setShape(new ImageTurtleShape("images", "timer.png"));
		maliarPozadia.setVisible(false);
	}

	public void start() {
		Stopky.zaciatocnyCas = System.currentTimeMillis();
		setTickPeriod(100);
	}

	public void stop() {
		setTickPeriod(0);
		maliarPozadia.stamp();
		pisar.print("000.0");
	}

	protected void onTick() {
		setTrvanie((int) (System.currentTimeMillis() - Stopky.zaciatocnyCas));
		clear();

		long seconds = getTrvanie() / 1000;
		long secondFraction = getTrvanie() % 1000 / 100;
		String secondsString = seconds + "." + secondFraction;
		if (seconds < 10) {
			secondsString = "0" + secondsString;
		}
		if (seconds < 100) {
			secondsString = "0" + secondsString;
		}
		maliarPozadia.stamp();
		pisar.print(secondsString);

	}

	public static long getTrvanie() {
		return trvanie;
	}

	public static void setTrvanie(long trvanie) {
		Stopky.trvanie = trvanie;
	}
}
