package sk.upjs.finalTerm.quoridor2;

import java.awt.Color;
import java.awt.Font;
import java.awt.event.MouseEvent;
import sk.upjs.jpaz2.*;
import sk.upjs.jpaz2.theater.*;

// jednoduche menu
public class UvodnaObrazovka extends Scene {

	// nazov sceny
	public static final String NAME = "Uvod";

	// korytnacky, ktore predstavuju policka
	private Turtle tlacitkoPocitac;
	private Turtle tlacitkoHrac;
	private Turtle tlacitkoPravidla;
	private Turtle tlacitkoStatistika;
	private Turtle tlacitkoExit;

	// korytnacka, ktora predstavuje ikonu hudby
	private HudbaOnOff hudbaOnOff;

	// konstruktor, pripravi uvodnu obrazovku
	public UvodnaObrazovka(Stage stage) {
		super(stage);
		pripravObrazovku();
	}

	// pripravi uvodnu obrazovku
	private void pripravObrazovku() {
		setBorderWidth(0);

		// nakresli pozadie
		Turtle painter = new Turtle();
		painter.setShape(new ImageShape("images", "introbackground.png"));
		add(painter);
		painter.center();
		painter.stamp();
		painter.setShape(new ImageShape("images", "streddosky.png"));
		painter.setPosition(this.getWidth() / 2, 440);
		painter.stamp();

		painter.setPosition(getWidth() / 2, 620);
		painter.setDirection(90);
		painter.setPenColor(new Color(149, 186, 196));
		painter.setFont(new Font("Trebuchet MS", 1, 20));
		painter.printCenter("© Matúš Revický, Paz1a, 2017/18, PF UPJŠ");
		remove(painter);

		// pripravi obrazky tlacidiel
		ImageShape hraci = new ImageShape("images", "hraci.png");
		ImageShape pocitac = new ImageShape("images", "pocitac.png");
		ImageShape pravidla = new ImageShape("images", "pravidla.png");
		ImageShape statistika = new ImageShape("images", "trophy.png");
		ImageShape exit = new ImageShape("images", "exit.png");

		// prida tlacidlo "PC vs hrac"
		tlacitkoPocitac = new Turtle();
		add(tlacitkoPocitac);
		tlacitkoPocitac.setPosition(150, 480);
		tlacitkoPocitac.setShape(pocitac);

		// prida tlacidlo "hrac vs hrac"
		tlacitkoHrac = new Turtle();
		add(tlacitkoHrac);
		tlacitkoHrac.setPosition(150, 560);
		tlacitkoHrac.setShape(hraci);

		// prida tlacidlo "pravidla"
		tlacitkoPravidla = new Turtle();
		add(tlacitkoPravidla);
		tlacitkoPravidla.setPosition(700, 490);
		tlacitkoPravidla.setShape(pravidla);

		// prida tlacidlo statistika
		tlacitkoStatistika = new Turtle();
		add(tlacitkoStatistika);
		tlacitkoStatistika.setPosition(700, 420);
		tlacitkoStatistika.setShape(statistika);

		// prida tlacidlo "exit"
		tlacitkoExit = new Turtle();
		add(tlacitkoExit);
		tlacitkoExit.setPosition(700, 560);
		tlacitkoExit.setShape(exit);

		// prida tlacidlo "hudba on/off"
		hudbaOnOff = new HudbaOnOff(getStage());
		hudbaOnOff.setPosition(5, 5);
		add(hudbaOnOff);
	}

	// vrati ci je kurzor nad danym tlacidlom
	private boolean jeNadTlacidlomPocitac(int x, int y) {
		return (tlacitkoPocitac.getX() - 60 <= x) && (x <= tlacitkoPocitac.getX() + 60)
				&& (tlacitkoPocitac.getY() - 30 <= y) && (y <= tlacitkoPocitac.getY() + 30);
	}

	private boolean jeNadTlacidlomHrac(int x, int y) {
		return (tlacitkoHrac.getX() - 60 <= x) && (x <= tlacitkoHrac.getX() + 60) && (tlacitkoHrac.getY() - 30 <= y)
				&& (y <= tlacitkoHrac.getY() + 30);
	}

	private boolean jeNadTlacidlomPravidla(int x, int y) {
		return (tlacitkoPravidla.getX() - 30 <= x) && (x <= tlacitkoPravidla.getX() + 30)
				&& (tlacitkoPravidla.getY() - 30 <= y) && (y <= tlacitkoPravidla.getY() + 30);
	}

	private boolean jeNadTlacidlomStatistika(int x, int y) {
		return (tlacitkoStatistika.getX() - 30 <= x) && (x <= tlacitkoStatistika.getX() + 30)
				&& (tlacitkoStatistika.getY() - 30 <= y) && (y <= tlacitkoStatistika.getY() + 30);
	}

	private boolean jeNadTlacidlomExit(int x, int y) {
		return (tlacitkoExit.getX() - 30 <= x) && (x <= tlacitkoExit.getX() + 30) && (tlacitkoExit.getY() - 30 <= y)
				&& (y <= tlacitkoExit.getY() + 30);
	}

	// zacne scenu a overi ci je hudba zapnuta
	public void start() {
		hudbaOnOff.aktualizujIkonu();
	}

	// ukonci scenu
	public void stop() {

	}

	@Override
	protected void onMouseReleased(int x, int y, MouseEvent detail) {
		// simulacia tlacidiel
		if (detail.getButton() == MouseEvent.BUTTON1) {
			// ak este nie je vytvorena scena "PocitacHrac" tak ju vytvori, prida do stage a
			// prepne na danu scenu
			if (jeNadTlacidlomPocitac(x, y)) {
				if (getStage().getScene(PocitacHrac.NAME) == null) {
					getStage().addScene(PocitacHrac.NAME, new PocitacHrac(getStage()));
				}
				getStage().changeScene(PocitacHrac.NAME, TransitionEffect.FADE_OUT_WHITE_FADE_IN, 1500);
				return;
			}

			// ak este nie je vytvorena scena "ClovekHrac" tak ju vytvori, prida do stage a
			// prepne na danu scenu
			if (jeNadTlacidlomHrac(x, y)) {
				if (getStage().getScene(ClovekHrac.NAME) == null) {
					getStage().addScene(ClovekHrac.NAME, new ClovekHrac(getStage()));
				}
				getStage().changeScene(ClovekHrac.NAME, TransitionEffect.FADE_OUT_WHITE_FADE_IN, 1500);
				return;
			}

			// prepne na pravidla (pridane do stagu uz bolo pri spusteni)
			if (jeNadTlacidlomPravidla(x, y)) {
				getStage().changeScene(Pravidla.NAME, TransitionEffect.FADE_OUT_WHITE_FADE_IN, 1500);
				return;
			}

			// prepne na Statistiku (pridane do stagu uz bolo pri spusteni)
			if (jeNadTlacidlomStatistika(x, y)) {
				getStage().changeScene(Statistika.NAME, TransitionEffect.FADE_OUT_WHITE_FADE_IN, 1500);
				return;
			}

			// vypne hru
			if (jeNadTlacidlomExit(x, y)) {
				System.exit(0);
			}
		}
	}

	@Override
	protected boolean onCanClick(int x, int y) {
		// zmeni kurzor mysi ak sa nachadza nad tlacidlami
		return super.onCanClick(x, y) || jeNadTlacidlomPocitac(x, y) || jeNadTlacidlomExit(x, y)
				|| jeNadTlacidlomHrac(x, y) || jeNadTlacidlomPravidla(x, y) || jeNadTlacidlomStatistika(x, y);
	}
}