package sk.upjs.finalTerm.quoridor2;

import sk.upjs.jpaz2.Turtle;

public class VypoctoveMetody {

	// uchovava zoznam navstivenych policok
	private static int[] naSkontrolovanieZoznam = new int[100];

	// zalozka, ktora zabezpecuje aby sa spravne zapisali polozky do pola
	// naSkontrolovanieZoznam na spravne indexy
	private static int naSkontrolovanieIndex = 1;
	// zalozka, ktora uchovava index kontrolovaneho policka
	private static int naKontroleIndex = 0;

	// metoda zisti, ci hrac je zablokovany, vracia true ak hrac je nezablokavany
	// ak je "koniec=82" znamena to, ze sa pytam, ci mam pristup ku najvrchnejsiemu
	// riadku
	// ak je "koniec=0" znamena to, ze sa pytam, ci mam pristup ku najspodnejsiemu
	// riadku

	public static boolean BreadthFirstSearch(int start, int koniec) {
		// vypracovane podla:
		// https://www.hackerearth.com/practice/algorithms/graphs/breadth-first-search/tutorial/

		// Vycisti zoznam(da vsade -1) a pridaj policko na ktorom sa hrac nachadza ako prve do
		// zoznamu
		vycistiZoznam();
		naSkontrolovanieZoznam[0] = start;

		// rob kym su este policka na skontrolovanie
		while (naKontroleIndex < naSkontrolovanieIndex) {
			int SucasnaPozicia = naSkontrolovanieZoznam[naKontroleIndex];

			// ak si nasiel koniec vrat true
			if (SucasnaPozicia == koniec) {
				return true;
			}

			// pridaj do pola naSkontrolovanieZoznam policka, ktore su pristupne z prave
			// kontrolovaneho policka a este nie su v zozname...

			// nalavo od kontrolovaneho
			int nalavoOdKontrolovaneho = Math.max(0, SucasnaPozicia - 1);
			if (zlavaOk(SucasnaPozicia) && !jeVpoliNaSkontrolovanie(nalavoOdKontrolovaneho)) {
				naSkontrolovanieZoznam[naSkontrolovanieIndex] = nalavoOdKontrolovaneho;
				naSkontrolovanieIndex++;
			}

			// napravo od kontrolovaneho
			int napravoOdKontrolovaneho = Math.min(82, SucasnaPozicia + 1);
			if (spravaOk(SucasnaPozicia) && !jeVpoliNaSkontrolovanie(napravoOdKontrolovaneho)) {
				naSkontrolovanieZoznam[naSkontrolovanieIndex] = napravoOdKontrolovaneho;
				naSkontrolovanieIndex++;
			}

			// pod kontrolovanym
			int podKontrolovanym = Math.min(82, SucasnaPozicia + 9);
			if (doleOk(SucasnaPozicia) && !jeVpoliNaSkontrolovanie(podKontrolovanym)) {
				naSkontrolovanieZoznam[naSkontrolovanieIndex] = podKontrolovanym;
				naSkontrolovanieIndex++;
			}

			// nad kontrolovanym
			int nadKontrolovanym = Math.max(0, SucasnaPozicia - 9);
			if (horeOK(SucasnaPozicia) && !jeVpoliNaSkontrolovanie(nadKontrolovanym)) {
				naSkontrolovanieZoznam[naSkontrolovanieIndex] = nadKontrolovanym;
				naSkontrolovanieIndex++;
			}

			// do pola naSkontrolovanieZoznam pridaj 0 ak je pristupny najspodnejsi riadok 
			if (SucasnaPozicia <= 9 && !jeVpoliNaSkontrolovanie(0)) {
				naSkontrolovanieZoznam[naSkontrolovanieIndex] = 0;
				naSkontrolovanieIndex++;
			}

			// do pola naSkontrolovanieZoznam pridaj 82 ak je pristupny najvrchnejsi riadok
			if (SucasnaPozicia >= 73 && !jeVpoliNaSkontrolovanie(82)) {
				naSkontrolovanieZoznam[naSkontrolovanieIndex] = 82;
				naSkontrolovanieIndex++;
			}
			naKontroleIndex++;
		}

		// Nikdy nenasiel koniec, vrat false
		return false;
	}

	// zisti ci sa nachadza v poli "naSkontrolovanieZoznam". Vrati false ak nie je
	public static boolean jeVpoliNaSkontrolovanie(int policko) {
		for (int j = 0; naSkontrolovanieZoznam[j] >= 0; j++) {
			if (naSkontrolovanieZoznam[j] == policko) {
				return true;
			}
		}
		return false;
	}

	public static void vycistiZoznam() {
		// vsetky prvky v "naSkontrolovanieZoznam" sa prepisu na -1
		
		for (int i = 0; i < naSkontrolovanieZoznam.length; i++) {
			naSkontrolovanieZoznam[i] = -1;
		}
		naSkontrolovanieIndex = 1;
		naKontroleIndex = 0;
	}

	// zisti ci sa da na dane policko dostat (kontroluje len ci mi nebrani stena)
	public static boolean zlavaOk(int pozícia) {
		if (pozícia % 9 != 1 && !HraciaDoska.getvSteny()[pozícia]
				&& !HraciaDoska.getvSteny()[Math.max(0, pozícia - 9)]) {
			return true;
		} else
			return false;
	}

	public static boolean spravaOk(int pozícia) {
		if (pozícia % 9 != 0 && !HraciaDoska.getvSteny()[pozícia + 1]
				&& !HraciaDoska.getvSteny()[Math.max(0, pozícia - 8)]) {
			return true;
		} else
			return false;
	}

	public static boolean horeOK(int pozícia) {
		if (pozícia > 9 && pozícia < 82 && !HraciaDoska.gethSteny()[pozícia]
				&& !HraciaDoska.gethSteny()[Math.max(0, pozícia - 1)]) {
			return true;
		} else
			return false;
	}

	public static boolean doleOk(int pozícia) {
		if (pozícia > 0 && pozícia <= 72 && !HraciaDoska.gethSteny()[Math.min(82, pozícia + 9)]
				&& !HraciaDoska.gethSteny()[Math.min(82, pozícia + 8)]) {
			return true;
		} else
			return false;
	}

	// vypocita mozne tahy korytnacky
	public static void vypocitajMozneTahy() {

		// ak je koniec hry, zveviditelni pomocne korytnacky (nevykresli mozne tahy)
		if (HraciaDoska.isKoniecHry()) {
			for (Turtle b : HraciaDoska.getMozneTahyKreslici()) {
				b.setVisible(false);
			}
		}
		if (HraciaDoska.isCervenyTah() && !HraciaDoska.isKoniecHry()) {

			HraciaDoska.getMozneTahy().clear();
			// cervene tahy

			// ak policko hore je pristupne a nie je na nom protihrac pridaj ho do pola
			// mozneTahy
			if (horeOK(HraciaDoska.getCervenyPozicia())
					&& HraciaDoska.getCervenyPozicia() - 9 != HraciaDoska.getModryPozicia()) {
				HraciaDoska.getMozneTahy().add(HraciaDoska.getCervenyPozicia() - 9);
			}
			// ak policko hore je pristupne a je na nom protihrac a dva policka nahor su
			// pristupne, pridaj ho do pola mozneTahy
			if (horeOK(HraciaDoska.getCervenyPozicia())
					&& HraciaDoska.getCervenyPozicia() - 9 == HraciaDoska.getModryPozicia()
					&& horeOK(HraciaDoska.getCervenyPozicia() - 9)) {
				HraciaDoska.getMozneTahy().add(HraciaDoska.getCervenyPozicia() - 18);
			}
			// ak policko hore je pristupne a je na nom protihrac a dva policka nahor su
			// nepristupne...
			if (horeOK(HraciaDoska.getCervenyPozicia())
					&& HraciaDoska.getCervenyPozicia() - 9 == HraciaDoska.getModryPozicia()
					&& (!horeOK(HraciaDoska.getCervenyPozicia() - 9))) {
				// ...a ak horne policko je pristupne sprava, pridaj toto policko do pola
				// mozneTahy
				if (spravaOk(HraciaDoska.getCervenyPozicia() - 9)) {
					HraciaDoska.getMozneTahy().add(HraciaDoska.getCervenyPozicia() - 9 + 1);
				}
				// ...a ak horne policko je pristupne zlava, pridaj toto policko do pola
				// mozneTahy
				if (zlavaOk(HraciaDoska.getCervenyPozicia() - 9)) {
					HraciaDoska.getMozneTahy().add(HraciaDoska.getCervenyPozicia() - 9 - 1);
				}
			}

			// vsetky ostatne tahy su ratane analogicky...
			if (spravaOk(HraciaDoska.getCervenyPozicia())
					&& HraciaDoska.getCervenyPozicia() + 1 != HraciaDoska.getModryPozicia()) {
				HraciaDoska.getMozneTahy().add(HraciaDoska.getCervenyPozicia() + 1);
			}
			if (spravaOk(HraciaDoska.getCervenyPozicia())
					&& HraciaDoska.getCervenyPozicia() + 1 == HraciaDoska.getModryPozicia()
					&& spravaOk(HraciaDoska.getCervenyPozicia() + 1)) {
				HraciaDoska.getMozneTahy().add(HraciaDoska.getCervenyPozicia() + 2);
			}
			if (spravaOk(HraciaDoska.getCervenyPozicia())
					&& HraciaDoska.getCervenyPozicia() + 1 == HraciaDoska.getModryPozicia()
					&& (!spravaOk(HraciaDoska.getCervenyPozicia() + 1))) {

				if (horeOK(HraciaDoska.getCervenyPozicia() + 1)) {
					HraciaDoska.getMozneTahy().add(HraciaDoska.getCervenyPozicia() - 9 + 1);
				}

				if (doleOk(HraciaDoska.getCervenyPozicia() + 1)) {
					HraciaDoska.getMozneTahy().add(HraciaDoska.getCervenyPozicia() + 9 + 1);
				}
			}

			// ====

			if (zlavaOk(HraciaDoska.getCervenyPozicia())
					&& HraciaDoska.getCervenyPozicia() - 1 != HraciaDoska.getModryPozicia()) {
				HraciaDoska.getMozneTahy().add(HraciaDoska.getCervenyPozicia() - 1);
			}
			if (zlavaOk(HraciaDoska.getCervenyPozicia())
					&& HraciaDoska.getCervenyPozicia() - 1 == HraciaDoska.getModryPozicia()
					&& zlavaOk(HraciaDoska.getCervenyPozicia() - 1)) {
				HraciaDoska.getMozneTahy().add(HraciaDoska.getCervenyPozicia() - 2);
			}
			if (zlavaOk(HraciaDoska.getCervenyPozicia())
					&& HraciaDoska.getCervenyPozicia() - 1 == HraciaDoska.getModryPozicia()
					&& (!zlavaOk(HraciaDoska.getCervenyPozicia() - 1))) {

				if (horeOK(HraciaDoska.getCervenyPozicia() - 1)) {
					HraciaDoska.getMozneTahy().add(HraciaDoska.getCervenyPozicia() - 9 - 1);
				}

				if (doleOk(HraciaDoska.getCervenyPozicia() - 1)) {
					HraciaDoska.getMozneTahy().add(HraciaDoska.getCervenyPozicia() + 9 - 1);
				}
			}

			// ====
			if (doleOk(HraciaDoska.getCervenyPozicia())
					&& HraciaDoska.getCervenyPozicia() + 9 != HraciaDoska.getModryPozicia()) {
				HraciaDoska.getMozneTahy().add(HraciaDoska.getCervenyPozicia() + 9);
			}
			if (doleOk(HraciaDoska.getCervenyPozicia())
					&& HraciaDoska.getCervenyPozicia() + 9 == HraciaDoska.getModryPozicia()
					&& doleOk(HraciaDoska.getCervenyPozicia() + 9)) {
				HraciaDoska.getMozneTahy().add(HraciaDoska.getCervenyPozicia() + 18);
			}
			if (doleOk(HraciaDoska.getCervenyPozicia())
					&& HraciaDoska.getCervenyPozicia() + 9 == HraciaDoska.getModryPozicia()
					&& (!doleOk(HraciaDoska.getCervenyPozicia() + 9))) {

				if (zlavaOk(HraciaDoska.getCervenyPozicia() + 9)) {
					HraciaDoska.getMozneTahy().add(HraciaDoska.getCervenyPozicia() + 9 - 1);
				}

				if (spravaOk(HraciaDoska.getCervenyPozicia() + 9)) {
					HraciaDoska.getMozneTahy().add(HraciaDoska.getCervenyPozicia() + 9 + 1);
				}
			}
		}

		// modre tahy
		if (!HraciaDoska.isCervenyTah() && !HraciaDoska.isKoniecHry()) {
			HraciaDoska.getMozneTahy().clear();
			// ====
			if (horeOK(HraciaDoska.getModryPozicia())
					&& HraciaDoska.getModryPozicia() - 9 != HraciaDoska.getCervenyPozicia()) {
				HraciaDoska.getMozneTahy().add(HraciaDoska.getModryPozicia() - 9);
			}

			if (horeOK(HraciaDoska.getModryPozicia())
					&& HraciaDoska.getModryPozicia() - 9 == HraciaDoska.getCervenyPozicia()
					&& horeOK(HraciaDoska.getModryPozicia() - 9)) {
				HraciaDoska.getMozneTahy().add(HraciaDoska.getModryPozicia() - 18);
			}
			if (horeOK(HraciaDoska.getModryPozicia())
					&& HraciaDoska.getModryPozicia() - 9 == HraciaDoska.getCervenyPozicia()
					&& (!horeOK(HraciaDoska.getModryPozicia() - 9))) {

				if (spravaOk(HraciaDoska.getModryPozicia() - 9)) {
					HraciaDoska.getMozneTahy().add(HraciaDoska.getModryPozicia() - 9 + 1);
				}

				if (zlavaOk(HraciaDoska.getModryPozicia() - 9)) {
					HraciaDoska.getMozneTahy().add(HraciaDoska.getModryPozicia() - 9 - 1);
				}
			}

			// ===
			if (spravaOk(HraciaDoska.getModryPozicia())
					&& HraciaDoska.getModryPozicia() + 1 != HraciaDoska.getCervenyPozicia()) {
				HraciaDoska.getMozneTahy().add(HraciaDoska.getModryPozicia() + 1);
			}
			if (spravaOk(HraciaDoska.getModryPozicia())
					&& HraciaDoska.getModryPozicia() + 1 == HraciaDoska.getCervenyPozicia()
					&& spravaOk(HraciaDoska.getModryPozicia() + 1)) {
				HraciaDoska.getMozneTahy().add(HraciaDoska.getModryPozicia() + 2);
			}
			if (spravaOk(HraciaDoska.getModryPozicia())
					&& HraciaDoska.getModryPozicia() + 1 == HraciaDoska.getCervenyPozicia()
					&& (!spravaOk(HraciaDoska.getModryPozicia() + 1))) {

				if (horeOK(HraciaDoska.getModryPozicia() + 1)) {
					HraciaDoska.getMozneTahy().add(HraciaDoska.getModryPozicia() - 9 + 1);
				}

				if (doleOk(HraciaDoska.getModryPozicia() + 1)) {
					HraciaDoska.getMozneTahy().add(HraciaDoska.getModryPozicia() + 9 + 1);
				}
			}

			// ====

			if (zlavaOk(HraciaDoska.getModryPozicia())
					&& HraciaDoska.getModryPozicia() - 1 != HraciaDoska.getCervenyPozicia()) {
				HraciaDoska.getMozneTahy().add(HraciaDoska.getModryPozicia() - 1);
			}
			if (zlavaOk(HraciaDoska.getModryPozicia())
					&& HraciaDoska.getModryPozicia() - 1 == HraciaDoska.getCervenyPozicia()
					&& zlavaOk(HraciaDoska.getModryPozicia() - 1)) {
				HraciaDoska.getMozneTahy().add(HraciaDoska.getModryPozicia() - 2);
			}
			if (zlavaOk(HraciaDoska.getModryPozicia())
					&& HraciaDoska.getModryPozicia() - 1 == HraciaDoska.getCervenyPozicia()
					&& (!zlavaOk(HraciaDoska.getModryPozicia() - 1))) {

				if (horeOK(HraciaDoska.getModryPozicia() - 1)) {
					HraciaDoska.getMozneTahy().add(HraciaDoska.getModryPozicia() - 9 - 1);
				}

				if (doleOk(HraciaDoska.getModryPozicia() - 1)) {
					HraciaDoska.getMozneTahy().add(HraciaDoska.getModryPozicia() + 9 - 1);
				}
			}

			// ====
			if (doleOk(HraciaDoska.getModryPozicia())
					&& HraciaDoska.getModryPozicia() + 9 != HraciaDoska.getCervenyPozicia()) {
				HraciaDoska.getMozneTahy().add(HraciaDoska.getModryPozicia() + 9);
			}
			if (doleOk(HraciaDoska.getModryPozicia())
					&& HraciaDoska.getModryPozicia() + 9 == HraciaDoska.getCervenyPozicia()
					&& doleOk(HraciaDoska.getModryPozicia() + 9)) {
				HraciaDoska.getMozneTahy().add(HraciaDoska.getModryPozicia() + 18);
			}
			if (doleOk(HraciaDoska.getModryPozicia())
					&& HraciaDoska.getModryPozicia() + 9 == HraciaDoska.getCervenyPozicia()
					&& (!doleOk(HraciaDoska.getModryPozicia() + 9))) {
				if (zlavaOk(HraciaDoska.getModryPozicia() + 9)) {
					HraciaDoska.getMozneTahy().add(HraciaDoska.getModryPozicia() + 9 - 1);
				}
				if (spravaOk(HraciaDoska.getModryPozicia() + 9)) {
					HraciaDoska.getMozneTahy().add(HraciaDoska.getModryPozicia() + 9 + 1);
				}
			}
		}
	}

	// vrati true ak je dana pozicia pristupna
	public static boolean jeMozne(int poloha) {
		for (int b : HraciaDoska.getMozneTahy()) {
			if (b == poloha) {
				return true;
			}
		}
		return false;
	}
}